<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_BookingRules StructType
 * @subpackage Structs
 */
class JP_BookingRules extends AbstractStructBase
{
    /**
     * The CruiseResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_CruiseResultsBookingRules
     */
    public $CruiseResult;
    /**
     * The FlightResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_FlightBookingRules
     */
    public $FlightResult;
    /**
     * The HotelResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_HotelResultsBookingRules
     */
    public $HotelResult;
    /**
     * The InsuranceResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_InsuranceBookingRules
     */
    public $InsuranceResult;
    /**
     * The PackageResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_PackageBookingRules
     */
    public $PackageResult;
    /**
     * The RentacarResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_RentacarResultsBookingRules
     */
    public $RentacarResult;
    /**
     * The ServiceResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_ServiceBookingRules
     */
    public $ServiceResult;
    /**
     * The TransferResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_TransferBookingRules
     */
    public $TransferResult;
    /**
     * The VisaResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_VisaBookingRules
     */
    public $VisaResult;
    /**
     * Constructor method for JP_BookingRules
     * @uses JP_BookingRules::setCruiseResult()
     * @uses JP_BookingRules::setFlightResult()
     * @uses JP_BookingRules::setHotelResult()
     * @uses JP_BookingRules::setInsuranceResult()
     * @uses JP_BookingRules::setPackageResult()
     * @uses JP_BookingRules::setRentacarResult()
     * @uses JP_BookingRules::setServiceResult()
     * @uses JP_BookingRules::setTransferResult()
     * @uses JP_BookingRules::setVisaResult()
     * @param \StructType\JP_CruiseResultsBookingRules $cruiseResult
     * @param \StructType\JP_FlightBookingRules $flightResult
     * @param \StructType\JP_HotelResultsBookingRules $hotelResult
     * @param \StructType\JP_InsuranceBookingRules $insuranceResult
     * @param \StructType\JP_PackageBookingRules $packageResult
     * @param \StructType\JP_RentacarResultsBookingRules $rentacarResult
     * @param \StructType\JP_ServiceBookingRules $serviceResult
     * @param \StructType\JP_TransferBookingRules $transferResult
     * @param \StructType\JP_VisaBookingRules $visaResult
     */
    public function __construct(\StructType\JP_CruiseResultsBookingRules $cruiseResult = null, \StructType\JP_FlightBookingRules $flightResult = null, \StructType\JP_HotelResultsBookingRules $hotelResult = null, \StructType\JP_InsuranceBookingRules $insuranceResult = null, \StructType\JP_PackageBookingRules $packageResult = null, \StructType\JP_RentacarResultsBookingRules $rentacarResult = null, \StructType\JP_ServiceBookingRules $serviceResult = null, \StructType\JP_TransferBookingRules $transferResult = null, \StructType\JP_VisaBookingRules $visaResult = null)
    {
        $this
            ->setCruiseResult($cruiseResult)
            ->setFlightResult($flightResult)
            ->setHotelResult($hotelResult)
            ->setInsuranceResult($insuranceResult)
            ->setPackageResult($packageResult)
            ->setRentacarResult($rentacarResult)
            ->setServiceResult($serviceResult)
            ->setTransferResult($transferResult)
            ->setVisaResult($visaResult);
    }
    /**
     * Get CruiseResult value
     * @return \StructType\JP_CruiseResultsBookingRules|null
     */
    public function getCruiseResult()
    {
        return $this->CruiseResult;
    }
    /**
     * Set CruiseResult value
     * @param \StructType\JP_CruiseResultsBookingRules $cruiseResult
     * @return \StructType\JP_BookingRules
     */
    public function setCruiseResult(\StructType\JP_CruiseResultsBookingRules $cruiseResult = null)
    {
        $this->CruiseResult = $cruiseResult;
        return $this;
    }
    /**
     * Get FlightResult value
     * @return \StructType\JP_FlightBookingRules|null
     */
    public function getFlightResult()
    {
        return $this->FlightResult;
    }
    /**
     * Set FlightResult value
     * @param \StructType\JP_FlightBookingRules $flightResult
     * @return \StructType\JP_BookingRules
     */
    public function setFlightResult(\StructType\JP_FlightBookingRules $flightResult = null)
    {
        $this->FlightResult = $flightResult;
        return $this;
    }
    /**
     * Get HotelResult value
     * @return \StructType\JP_HotelResultsBookingRules|null
     */
    public function getHotelResult()
    {
        return $this->HotelResult;
    }
    /**
     * Set HotelResult value
     * @param \StructType\JP_HotelResultsBookingRules $hotelResult
     * @return \StructType\JP_BookingRules
     */
    public function setHotelResult(\StructType\JP_HotelResultsBookingRules $hotelResult = null)
    {
        $this->HotelResult = $hotelResult;
        return $this;
    }
    /**
     * Get InsuranceResult value
     * @return \StructType\JP_InsuranceBookingRules|null
     */
    public function getInsuranceResult()
    {
        return $this->InsuranceResult;
    }
    /**
     * Set InsuranceResult value
     * @param \StructType\JP_InsuranceBookingRules $insuranceResult
     * @return \StructType\JP_BookingRules
     */
    public function setInsuranceResult(\StructType\JP_InsuranceBookingRules $insuranceResult = null)
    {
        $this->InsuranceResult = $insuranceResult;
        return $this;
    }
    /**
     * Get PackageResult value
     * @return \StructType\JP_PackageBookingRules|null
     */
    public function getPackageResult()
    {
        return $this->PackageResult;
    }
    /**
     * Set PackageResult value
     * @param \StructType\JP_PackageBookingRules $packageResult
     * @return \StructType\JP_BookingRules
     */
    public function setPackageResult(\StructType\JP_PackageBookingRules $packageResult = null)
    {
        $this->PackageResult = $packageResult;
        return $this;
    }
    /**
     * Get RentacarResult value
     * @return \StructType\JP_RentacarResultsBookingRules|null
     */
    public function getRentacarResult()
    {
        return $this->RentacarResult;
    }
    /**
     * Set RentacarResult value
     * @param \StructType\JP_RentacarResultsBookingRules $rentacarResult
     * @return \StructType\JP_BookingRules
     */
    public function setRentacarResult(\StructType\JP_RentacarResultsBookingRules $rentacarResult = null)
    {
        $this->RentacarResult = $rentacarResult;
        return $this;
    }
    /**
     * Get ServiceResult value
     * @return \StructType\JP_ServiceBookingRules|null
     */
    public function getServiceResult()
    {
        return $this->ServiceResult;
    }
    /**
     * Set ServiceResult value
     * @param \StructType\JP_ServiceBookingRules $serviceResult
     * @return \StructType\JP_BookingRules
     */
    public function setServiceResult(\StructType\JP_ServiceBookingRules $serviceResult = null)
    {
        $this->ServiceResult = $serviceResult;
        return $this;
    }
    /**
     * Get TransferResult value
     * @return \StructType\JP_TransferBookingRules|null
     */
    public function getTransferResult()
    {
        return $this->TransferResult;
    }
    /**
     * Set TransferResult value
     * @param \StructType\JP_TransferBookingRules $transferResult
     * @return \StructType\JP_BookingRules
     */
    public function setTransferResult(\StructType\JP_TransferBookingRules $transferResult = null)
    {
        $this->TransferResult = $transferResult;
        return $this;
    }
    /**
     * Get VisaResult value
     * @return \StructType\JP_VisaBookingRules|null
     */
    public function getVisaResult()
    {
        return $this->VisaResult;
    }
    /**
     * Set VisaResult value
     * @param \StructType\JP_VisaBookingRules $visaResult
     * @return \StructType\JP_BookingRules
     */
    public function setVisaResult(\StructType\JP_VisaBookingRules $visaResult = null)
    {
        $this->VisaResult = $visaResult;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_BookingRules
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
